/******************************************************************************
 * hWeb --- Simple Web Reader
 ******************************************************************************
 * areas.c : create list available aeras
 *
 * Copyright (C) 2007-2016
 *
 * Evgeny Vetrov
 *
 * Fido:     2:6037/7@fidonet
 * Internet: <vea713@gmail.com>, <vea@smekal.ru>
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *****************************************************************************
 */

#include <string.h>
#include <fidoconf/fidoconf.h>
#include <smapi/msgapi.h>

int main(int argc, char *argv[])
{
	const char *header = "Content-Type:text/html;charset=cp866\n";
	char *tmp = NULL;

	ps_fidoconfig config = NULL;
	MSGA *smapi_area = NULL;
	ps_area aptr = NULL;
	unsigned int i = 0;

	if ( (config = readConfig(getConfigFileName())) == NULL )
	{
		printf("%sStatus: 500\n\nERROR: can`t read config", header);
		return 0;
	}

	tmp = getenv("HTTP_IF_NONE_MATCH");

	if ( tmp != NULL && !strcmp(tmp, "1") )
	{
		printf("%sStatus: 304\n\n",header);
		disposeConfig(config);
		return 0;
	}

	printf(
	"%sAge: 3600\n"
	"ETag: %s\n"
	"\n"
	"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n"
	"<html>\n"
	"<head>\n"
	"\t<title>LIST_AREAS</title>\n"
	"\t<LINK href=\"/main.css\" rel=\"stylesheet\" type=\"text/css\"/>\n"
	"</head>\n"
	"<body>\n"
	"<table id=\"AREAS\">\n"
	"<tr><th>Area</th><th>Num Msg</th><th>Description</th></tr>"
	, header
	, "1"
	);

	if ( config->echoAreaCount > 0 )
	{
		aptr = config->echoAreas;
		for (i = 0; i < config->echoAreaCount; i++, aptr++)
		{
			if ( (smapi_area = MsgOpenArea((byte *)aptr->fileName, MSGAREA_CRIFNEC, aptr->msgbType)) != NULL)
			{
				printf(
				"<tr><td><a href=\"msgs.cgi?area=%s\" target=\"MSGS\">%s</a></td><td>%lu</td><td>%s</td></tr>\n"
				, aptr->areaName
				, aptr->areaName
				, smapi_area->num_msg
				, aptr->description
				);

				MsgCloseArea(smapi_area);
			}
		}
	}
	printf(
	"</table>\n"
	"</body/>\n"
	"</html>\n"
	);

	disposeConfig(config);
	return 0;
}
